<%--------------------------------

			Content

----------%><%

	out.println('\n\t\t\t<article id="main-cont" class="content base-overlay ' + ((typeof differentBackgroundFor !== 'undefined')?  ('different-' + differentBackgroundFor) : '') + '">');

	var	getFolderThumb = function(ao) {
				var vars = ao.getVars(),
					s;

				// Iconpath => SVG, folder thumb path
				if (s = vars.get('iconPath')) {
					s = s.replace('folder.png', defaultFolderIconName);
					return s.replace(/^\.\.\//, '');
				} else {
					return createFolderThumb(ao, folderThumbSize, true);
				}
			},
			
		getNewImagesContent = function(ao) {
				var vars = ao.getVars(),
					t = vars.get('fileTitle'),
					d;
				
				d = {
						fn:				'collectByDate',
						start:			today - (vars.get('newImagesDays') || 30),
						depth:			vars.get('newImagesDepth') || 'tree',
						sortBy:			vars.get('newImagesSort') || 'date',
						reference:		vars.get('newImagesSource') || 'dateTaken',
						reverse:		vars.get('newImagesReverse') || false,
						linkMore:		vars.get('closeupPath')
					};
				
				return (t? ('<h3>' + t + '</h3>') : '') + 
					'<div class="new-images single-row" data-jalbum-query=\'' + JSON.stringify(d) + '\'></div>';
			};
			
	/******************************************************************
	 *
	 *						Main Content
	 *
	 ******************************************************************/
	
	 // No predefined sections order
	sectionsOrder = (typeof sectionsOrder === 'undefined')? 'story\tneighboringFolders\tcommenting\tcustomContent' : sectionsOrder;
	
	for each (section in sectionsOrder.split('\t')) {

		switch (section) {

			case 'story':

				// The main section

				var thumbs = [],		// Thumbnails buffer
					pages = [],			// Pages buffer
					weblocs = [],		// Web location buffer
					folders = [],		// folders
					fn = 0,				// Folder number
					n = 0,				// Image number
					cat,				// Category
					
					// Writing out all cached thumbnails
					writeOutThumbnails = function() {

							//print('Writing out thumbs [' + thumbs.length + ']');

							out.print('\t\t\t\t<section class="thumbnails"><div class="cont thumb-cont ' + 
									[	thumbLayout, 
										'caption-' + captionPlacement,
										'caption-' + captionStyle,
										(thumbs.length >= columns)? 'multi' : ('single cnt-' + thumbs.length)
									].join(' ') +
								'">');

							for each (ao in thumbs) {

								var vars 	= ao.getVars(),
									cat		= ao.getCategory(),
									tp		= vars.get('thumbPath'),
									ip 		= vars.get((cat === Category.video || cat === Category.audio)? 'contentPath' : 'imagePath'),
									tw		= parseInt(vars.get('thumbWidth')),
									th		= parseInt(vars.get('thumbHeight')),
									ar		= tw / th,
									c 		= vars.get('thumbCaption'),
									t 		= stripHTML(vars.get('title')) || vars.get('label');
	
								//data = collectData(ao);

								out.print('<div class="card ' + ((n < preloadThumbs)? 'preload' : 'lazyload') + ' ' + 
										((cat === Category.video || cat === Category.audio)? 'media' : '') + ' ' + 
										((ar >= 1.25)? 'landscape' : ((ar <= 0.8)? 'portrait' : 'square')) + 		// AR type
									'"');
								
								if (thumbLayout === 'masonry') {
									//out.print(' style="max-width:' + Math.round(tw * 1.25) + 'px;"');
									out.print(' style="width:' + ((thumbs.length >= columns)? Math.round(tw * 0.8) : tw) + 'px;"');
								}
								
								out.print('><a class="image' +
									(tp.toLowerCase().endsWith('.png')? ' iconthumb' : '') +
									((tw < maxThumbWidth && th < maxThumbHeight)? ' tiny' : '') + 
									'" href="' + ip + '">');

								if (n < preloadThumbs) {
									// Adding thumbnail for preload
									out.print('<img src="' + tp + '"' +
											((t && addAltTags)? (' alt="' + t.replace(/"/g, '&#34;') + '"') : '') +				// '
										'>');
								}

								out.print('</a>');

								if (c) {
									// Caption
									out.print('<div class="caption">' + c + '</div>');
								}

								out.print('</div>');

								n++;
							}

							out.println('</div></section>');
						},
						
					// Writing out cached folders
					writeOutFolders = function() {
						
							out.println('\t\t\t\t<section class="folders">');
							
							if (folders.length > 1 || folderColumns > 1) {
								// Creating container for more than 1 columns
								out.println('\t\t\t\t\t<div class="cont">');
							}
							
							for each (f in folders) {
								
								var	vars = f.getVars(),
									cp = getExternalLink(vars) || vars.get('closeupPath'),
									ip = vars.get('iconPath'),
									tp = ip? (resPath + '/' + defaultFolderIconName) : getFolderThumb(f),
									cnt = getCountObj(f),
									t = vars.get('title'),
									c  = vars.get('thumbCaption'),
									wl = f.getCategory() === Category.webLocation,
									counts = (wl || showFolderImageCount)? vars.get('counts') : '',
									ask = vars.get('askPermission'),
									mosaic = folderMosaic? getRandomChildren(f, 3, 'image,video,folder,webLocation', true, true) : null;
								
								ask = (ask !== null)? (' data-ask-permission=\'' + ask.replace(/'/g, '&apos;') + '\'') : '';		//'
		
								// Folder thumbnail
								out.print('\t\t\t\t\t\t<div class="' +
										[	'foldercard',
											(folders.length === 1)? 'cont' : '',
											'grid-' + folderColumns,
											(mosaic && mosaic.length)? 'hasmosaic' : 'nomosaic',
											(fn >= preloadThumbs)? 'lazyload' : 'preload',
											wl? 'webloc' : ''
										].filter(Boolean).join(' ') + 
									'">');
								
								out.print('<a href="' + cp + '" class="thumb' + (ip? ' icon' : '') + '"' + ask +
										((fn >= preloadThumbs)? 
											(' data-src="' + tp + '">') 
											:
											('><img src="' + tp + '"' + (addAltTags? (' alt="' + stripHTML(t + ' ' + shorten(c, 120, true)).replace(/"/g, '&#34;') + '"') : '') + '>')		// '
										) +
									'</a>');
		
								if (mosaic && mosaic.length) {
									// Mosaic
	
									var fp = vars.get('closeupPath').replace(indexName, '');
	
									out.print('<div class="mosaic">');

									for (var i = 0, lnk, l = mosaic.length; i < l; i++) {
										cat = mosaic[i].getCategory();
										vars = mosaic[i].getVars();
										t = stripHTML(vars.get('title') || vars.get('label'));
										
										if (cat === Category.folder && (tp = vars.get('iconPath'))) {
											tp = resPath + '/' + defaultFolderIconName;
										} else {
											var imf = mosaic[i].getParent(),
												rp = [];
											
											while (imf !== null && imf !== f) {
												print(f.getWebName() + " <> " + imf.getWebName());
												rp.push(imf.getWebName());
												imf = imf.getParent();
											}
											
											rp = rp.length? (rp.reverse().join('/') + '/') : '';
											tp = fp + rp + vars.get('thumbPath');
										}
										
										lnk = fp + rp + indexName;
										//print('\tthumb[' + i + '] ' + cp + mosaic[i].getVars().get('thumbPath'));
										out.print('<a href="' + 
												((cat === Category.folder || i === l - 1)? lnk : (lnk + '#img=' + mosaic[i].getWebName())) + '"' +
												ask +
												((fn >= preloadThumbs)? 
													(' data-src="' + tp + '">')
													: 
													('><img src="' + tp + '"' + (addAltTags? (' alt="' + t.replace(/"/g, '&#34;') + '"') : '') + '>' )		// ' 
												) + 
												((i === l - 1)? '<span>+<small>' + Math.max(1, (cnt.image + cnt.audio + cnt.video - mosaic.length)) + '</small></span>' : '') + 
											'</a>');
									}

									out.print('</div>');
								}
								
								if (c) {
									// Adding link in the header element
									c = c.replace(/(<h\d>)/gi, '$1<a href="' + cp + '"' + ask + '>').replace(/(<\/h\d>)/gi, '<\/a>$1');
									// Caption
									out.print('<div class="caption">' + c + counts + '</div>');
								} else {
									out.print('<div class="caption"><h3><a href="' + cp + '">' + t + '</a></h3></div>');
								}
								
								out.println('</div>');
								fn++;

							}

							if (folders.length > 1 || folderColumns > 1) {
								out.println('\t\t\t\t\t</div>');
							}
							
							out.println('\t\t\t\t</section>');
						
						},
					
					// Writing out cached pages
					writeOutPages = function() {
							//print('Writing out pages [' + pages.length + ']');

							out.print('\t\t\t\t<section class="pages"><div class="cont pages-cont">');

							for each (ao in pages) {

								var vars 	= ao.getVars(),
									cp		= vars.get('closeupPath'),
									t 		= cleanup(stripHTML(vars.get('title')) || vars.get('label')),
									c 		= (showPages === 'excerpt')? vars.get('comment') : '';
	
								out.print('<div class="page-card">');
								
								out.print('<h6><a class="page icon-page button" href="' + cp + '"> ' + t + '</a></h6>');								
								
								if (c) {
									out.print('<div class="comment">' + c + '</div>');
								}

								out.print('</div>');
							}

							out.println('</div></section>');
						
						},
						
					// Writing out cached web locations
					writeOutWeblocs = function() {
							//print('Writing out web locations [' + weblocs.length + ']');
							// showWeblocations: none, link, smallThumb, thumb, asFolder, embed
							
							var	target = webLocationOpenNew? ' target="_blank"' : '';

							out.print('\t\t\t\t<section class="weblocs"><div class="cont weblocs-cont">');
							
							for each (ao in weblocs) {

								var vars 	= ao.getVars(),
									cp		= vars.get('closeupPath'),
									t 		= vars.get('title') || vars.get('label'),
									alt		= addAltTags? (' alt="' + cleanup(stripHTML(t)).replace(/"/g, '&#34;') + '"') : '',		//'
									c 		= vars.get('comment');
								
								
								if (showWeblocations === 'link') {
									// Link only
									out.print('<div class="card link">' +
											'<a class="icon-external" href="' + cp + '"' + target + ' data-tooltip title="' + c + '"> ' + t + '</a>' +
										'</div>');
										
								} else if (showWeblocations === 'smallThumb' || showWeblocations === 'thumb') {
									// Thumbnail with optional caption
									var tp;
									
									if (showWeblocations === 'smallThumb' || webLocationCaptionPlacement === 'beside') {
										tp = vars.get('thumbPath');
									} else {
										tp = vars.get('imagePath');
									}
									
									out.print('<div class="card ' +
											((showWeblocations === 'smallThumb')? 
												'smallthumb' 
												: 
												('thumbnail caption-' + webLocationCaptionPlacement)
											) +
										'">' +
										'<a class="thumb' + (tp? '' : ' icon') + '" ' + 
											'href="' + cp + '"' + target + '>' +
											'<img src="' + (tp || (resPath + 'htt.png')) + '"' + alt + '>' +
										'</a>');
										
									// Caption
									if (webLocationCaptionPlacement !== 'hide') {
										out.print('<div class="caption' + (tp? '' : ' icon-earth') + '">' +
												'<h6><a href="' + cp + '"' + target + '>' + t + '</a></h6>' +									
												(c? ('<div class="comment">' + c + (gatherWeblocationInfo? vars.get('counts'):'') + '</div>') : '') +
											'</div>');
									}
									
									out.print('</div>');
									
								} else {
									// As folder
									var	ip = vars.get('imagePath');
			
									out.println('\t\t\t\t<section class="folder">' +
										'<div class="foldercard cont preload">' +
											'<a href="' + cp + '" class="thumb' + (ip? '' : ' icon') + '">' +
												'<img src="' + (ip || (resPath + 'folder.png')) + '"' + alt + '>' +
											'</a>' +
											'<div class="caption">' +
												'<h3>' + t + '</h3>' +
												(c? ('<div class="comment">' + c + vars.get('counts') + '</div>') : '') +
											'</div>' +
										'</div></section>');
								}
								
							}

							out.println('</div></section>');
						
						},
						
					// Write out all accumulated items (cat = the new item's category that triggers the flusing)
					flushBuffers = function(cat) {
							var cat = cat || null;
							
							if (folders.length && cat !== Category.folder) {
								writeOutFolders();
								folders = [];
							}
							
							if (weblocs.length && cat !== Category.webLocation) {
								writeOutWeblocs();
								weblocs = [];
							}
							
							if (pages.length && cat !== Category.webPage) {
								writeOutPages();
								pages = [];
							}
							
							if (thumbs.length && 
								(	!cat ||
									cat === Category.webPage || 
									cat === Category.webLocation || 
									cat === Category.folder
								)
							) {
								writeOutThumbnails();
								thumbs = [];
							}
							
						};
						
				// Iterating over all items
				currentFolder.getChildren().forEach(function(ao) {

					if (ao.isIncluded()) {
						
						cat = ao.getCategory();
	
						//print(ao.getName() + ' [' + cat + ']');
	
						if (cat === Category.folder) {
	
							// Folders, webpages
							if (!ao.isHidden()) {
								
								flushBuffers(cat);
								folders.push(ao);
							}
	
						} else if (cat === Category.webLocation) {
							
							if (/*!ao.isHidden() && */showWeblocations !== 'none') {
								if (showWeblocations !== 'embed') {
									if (showWeblocations === 'asFolder') {
										flushBuffers(Category.folder);
										folders.push(ao);
									} else {
										flushBuffers(cat);
										weblocs.push(ao);
									}
								} else {
									flushBuffers();
									out.println('\t\t\t\t<section class="custom">');
										out.println('\t\t\t\t\t<div class="cont embed-container">');
											out.println('<iframe src="' + ao.getVars().get('closeupPath') + '" style="border:0"></iframe>');
										out.println('\t\t\t\t\t</div>');
									out.println('\t\t\t\t</section>');
								}
							}
						
						} else if (cat === Category.webPage) {
	
							if (!ao.isHidden() && showPages !== 'none') {
								
								if (showPages === 'embed' || showPages === 'embedCustom' && !isPredefinedPage(ao)) {
									var s;
									
									flushBuffers();
									
									s = (ao.getName() === 'Newimages.htt')? 
										getNewImagesContent(ao)
										:
										getCustomPageContent(ao);
									
									if (s) {
										out.println('\t\t\t\t<section class="custom ' + ao.getName().toLowerCase().replace(/(-\d+)?\.htt$/, '-page') + '">');
											out.println('\t\t\t\t\t<div class="page-wrap cont">');
												out.println(s);
											out.println('\t\t\t\t\t</div>');
										out.println('\t\t\t\t</section>');
									}
									
								} else {
									flushBuffers(cat);
									pages.push(ao);
								}
							}
	
						} else if (isSimpleObject(ao)) {
	
							var	vars 	= ao.getVars(),
								treat	= vars.get('treatImageAs'),
								iw  	= parseInt(vars.get('imageWidth')),				// Image width
								ih  	= parseInt(vars.get('imageHeight')),			// Image height
								ow  	= parseInt(vars.get('originalWidth')),			// Original width
								c,
								t		= stripHTML(ao.getTitle() || ao.getName()),		// title
								ar		= iw / ih;										// Aspect ratio
							
							if ((!treat && ar > thumbThreshold) || treat === 'single' || treat === 'fullwidth') {
								// Single or fullwidth image
								flushBuffers();
								
								var fullw = (treat !== 'single') && 
											(treat === 'fullwidth' || 
												(ar >= wideThreshold && ow >= 1600 && cat !== Category.video && cat !== Category.audio)
											);
								
								// Container
								if (fullw) {
									out.print('\t\t\t\t<div class="wide"><div class="card');
								} else {
									out.print('\t\t\t\t<div class="single"><div class="cont card');
								}
								
								if (cat === Category.video || cat === Category.audio) {
									out.print(' media');
								}
								
								//print('Treating image "' + ao.getName() + '" as "' + (fullw? 'fullWidth' : 'single') + '"  because ' + (treat? ('treatAs set to "' + treat + '"') : ('aspect ratio is "' + ar.toFixed(3) + '"')));
								
								out.print(' caption-' + captionPlacement + ' ' + ((n < preloadThumbs)? 'preload':'lazyload') + '">');
	
								if (cat === Category.video || cat === Category.audio) {
									out.print('<' + cat + ' data-media="' + encodeURIComponent(vars.get('fileName')) + '" class="' + cat + ' image" src="' + vars.get('originalPath') + 
										'" poster="' + vars.get('imagePath') + 
										'" controls controlslist="nodownload"></' + cat + '>' +
										'<a class="opener icon-expand"></a>'
									);
								} else {
									// Image // path to slide image
									out.print('<a class="image' + ((ar >= 2)? ' pano' : '') + '" href="' + vars.get('imagePath') + '">');
		
										// IMG
										if (n < preloadThumbs) { 														
											// Preloaded thumbnail 
											out.print('<img src="' + vars.get('imagePath') +
												'" alt="' + t.replace(/"/g, '&#34;') + '">'); 
											//'
										}
		
									out.print('</a>');
								}
								
								if (fullw) {
									// Full width image
									if (fullCaptionTemplate && (c = processTemplate(ao, fullCaptionTemplate))) {
										out.print('<div class="cont caption' + (c.match(/^<h[1-3]/)? ' hastitle' : '') + '">' + c + '</div>');
									}
								} else {
									// Wide image
									if (singleCaptionTemplate && (c = processTemplate(ao, singleCaptionTemplate))) {
										out.print('<div class="caption">' + c + '</div>');
									}
								}
	
								out.println('</div></div>');
	
								n++
	
							} else {
								// Regular thumbnail
								flushBuffers(cat);
								// Push to gallery
								thumbs.push(ao);
							}
	
						}	
					}
				});

				flushBuffers();

				break;

			case 'neighboringFolders':

				if (level && linkNeighboringFolders) {

					if ((typeof previousFolderPath !== UNDEF) && previousFolderPath || 
						(typeof nextFolderPath !== UNDEF) && nextFolderPath) {
						
						out.print('\t\t\t\t<section class="prev-next-links"><div class="cont">');

						if (previousFolderPath) {
							out.print('<div class="previous-link' +
									((neighboringFolderBgImage && previousFolderThumbPath)? (' has-bg" style="background-image:url(' + previousFolderThumbPath + ')"') : ' no-bg"') +
								'>' + 
									'<a rel="prev" href="' + previousFolderPath + indexName + '"' +
										((typeof previousFolderAsk !== UNDEF)? (' data-ask-permission="' + previousFolderAsk + '"') : '') +
									'>' +
										'<span class="caption"><span class="icon-caret-left"></span> ' + previousFolderTitle + '</span>' +
									'</a>' +
								'</div>');
						}

						if (nextFolderPath && nextFolderPath !== previousFolderPath) {
							out.print('<div class="next-link' +
									((neighboringFolderBgImage && nextFolderThumbPath)? (' has-bg" style="background-image:url(' + nextFolderThumbPath + ')"') : ' no-bg"') +
								'>' + 
									'<a rel="next" href="' + nextFolderPath + indexName + '"' + 
										((typeof nextFolderAsk !== UNDEF)? (' data-ask-permission="' + nextFolderAsk + '"') : '') +
									'>' +
										'<span class="caption">' + nextFolderTitle + ' <span class="icon-caret-right"></span></span>' +
									'</a>' +
								'</div>');
						}

						out.println('</div></section>');
					}
				}

				break;

			case 'commenting':

				if (_useFacebookCommenting || _useDisqusCommenting) {

					out.println('\t\t\t\t<section class="commenting">' +
							(_useFacebookCommenting? ('<div class="fb-comments cont" id="fb-comments" data-num-posts="' + facebookCommentingPosts + '" data-width="100%" data-colorscheme="' + commentingTheme + '"' + (pageUrl? ' (data-href="' + pageUrl + '")' : '') + '></div>') : '') +
							(_useDisqusCommenting? '<div class="disqus-comments cont" id="disqus-comments"><div id="disqus_thread"></div></div>' : '') +
						'</section>');
				}

				break;

			case 'customContent':

				if (customContent && (!level || !customContentTopLevelOnly)) {
					out.println('\t\t\t\t<section class="custom-content">' + 
							(customContentFitWidth? '<div class="cont">' : '') +
								getProcessed(customContent) + 
							(customContentFitWidth? '</div>' : '') +
						'</section>');
				}

				break;
		}
	}
	
	out.println('\t\t\t</article>');
%>
